part of modern_form_core;

enum ModernFormTextFieldListennerType { Text, Money, Number }

extension ModernFormTextFieldListennerTypeExtensions
    on ModernFormTextFieldListennerType? {
  TextInputType get toKeyboardType {
    switch (this) {
      case ModernFormTextFieldListennerType.Text:
        return TextInputType.text;
      case ModernFormTextFieldListennerType.Money:
        return TextInputType.number;
      case ModernFormTextFieldListennerType.Number:
        return TextInputType.number;
      default:
        return TextInputType.text;
    }
  }
}

extension ModernFormTextFieldListennerExtensions
    on ModernFormTextFieldListenner {
  TextEditingController toController() {
    switch (this.type) {
      case ModernFormTextFieldListennerType.Text:
        return TextEditingController(text: this.value?.toString() ?? "");
      case ModernFormTextFieldListennerType.Money:
        return MoneyMaskedTextController(
          initialValue: this.value is num ? this.value.toDouble() : 0.0,
          rightSymbol: this.rightSymbol ?? '',
          leftSymbol: this.leftSymbol ?? "R\$ ",
          decimalSeparator: this.decimalSeparator ?? ",",
        );
      case ModernFormTextFieldListennerType.Number:
        return MoneyMaskedTextController(
          initialValue: this.value is num ? this.value.toDouble() : 0.0,
          precision: this.precision ?? 0,
          decimalSeparator: this.decimalSeparator != null
              ? this.decimalSeparator!
              : (this.precision == null || this.precision == 0)
                  ? ""
                  : ",",
          leftSymbol: this.leftSymbol ?? '',
          rightSymbol: this.rightSymbol ?? '',
        );
      default:
        return TextEditingController(text: this.value?.toString() ?? "");
    }
  }
}
